
function createIssue() {
  client.interface.trigger('showModal', {
    title: 'Create Youtrack Issue',
    template: 'create.html'
  })
    .then(
      function (data) {
        console.log('Parent:InterfaceAPI:showModal', data);
      },
      function (error) {
        console.log('Parent:InterfaceAPI:showModal', error);
      }
    );
};

function linkIssue() {
  client.interface.trigger('showModal', {
    title: 'Link Youtrack Issue(s)',
    template: 'link.html'
  })
    .then(
      function (data) {
        console.log('Parent:InterfaceAPI:showModal', data);
      },
      function (error) {
        console.log('Parent:InterfaceAPI:showModal', error);
      }
    );
    getETs()
};

function editIssue() {
  client.interface.trigger('showModal', {
    title: 'Edit Youtrack Issue',
    template: 'edit.html'
  })
    .then(
      function (data) {
        console.log('Parent:InterfaceAPI:showModal', data);
      },
      function (error) {
        console.log('Parent:InterfaceAPI:showModal', error);
      }
    );
};

function getYoutrackUrls(data) {
  if(data.ticket.custom_fields['cf_engineering_triage_url']) {
    // Escalation url provided so we update fields and hide/show where required
    escalation_url = data.ticket.custom_fields['cf_engineering_triage_url'];
    var index = escalation_url.lastIndexOf("/");
    var short_ticket = escalation_url.substring(index+1);
    // Create link to ET ticket
    $('#escalation-data').html('<a href="' + escalation_url + '" target="_blank">' + short_ticket + "</a>");
    $('#issue-unlink').removeClass('hide');
    $('#issue-edit').removeClass('hide');
    // Hide buttons to create and link to ET ticket
    $('#no-links').addClass('hide');
  }
}

$(document).ready(function () {
  app.initialized()
    .then(function (_client) {
      var client = _client;
      window.client = client;
      client.events.on('app.activated',
        function () {
          client.data.get('ticket')
            .then(function (data) {
                getYoutrackUrls(data);
            })
            .catch(function (e) {
              console.log('Exception - ', e);
            });
        });
    });
});

// Ayoub's code below, Dave's initial code above this comment

var headers = "Authorization: Bearer perm:RnJlc2hkZXNr.eW91dHJhY2s=.0kAH1tymX9H906vUl5pYFkTmyqTH3O";
var options = { headers: headers };

function createET() {
  var url = "http://localhost:8080/api/issues?fields=idReadable";
  var body = {
    "project": {"id": "0-0"},
    "summary": document.getElementById("summaryId").value,
    "description": document.getElementById("descriptionId").value,
    "customFields": [
      {
        "name": "Priority",
        "$type": "SingleEnumIssueCustomField",
        "value": document.getElementById("priorityId").value
      },
      {
        "name": "Assignee",
        "$type": "SingleUserIssueCustomField",
        "value": document.getElementById("assigneeId").value
      },
      {
        "name": "Subsystem",
        "$type": "SingleUserIssueCustomField",
        "value": "No Subsystem"
      }
    ]
  }
  console.log(body)
  client.request.post(url, options, body)
  .then(
    function(data) {
      console.log(data);
    },
    function(error) {
      console.log(error);
    }
  )
}

function getETs() {
  var url = "http://localhost:8080/api/issues?fields=idReadable,summary&query=project:ET";
  client.request.get(url, options)
  .then(
    function(data) {
      console.log(data);
      for (let x in data.response) {
        var ET_ticket = data.response[x].idReadable;
        var ET_summmary = data.response[x].summary;
        
      }
      console.log(ET_ticket);
    },
    function(error) {
      console.log(error);
    }
  )
}

function setFDuser() {
  var url = "http://localhost:8080/api/issues?fields=idReadable";
  var body = {
    "name": "FD Users",
    "$type": "SingleUserIssueCustomField",
    "value": document.getElementById("edit_FDuserId").value
  }
  console.log(body)
  client.request.post(url, options, body)
  .then(
    function(data) {
      console.log(data);
    },
    function(error) {
      console.log(error);
    }
  )
}

function getFDusers() {
  url = "https://support.featurespace.com/api/v2/agents"
  client.request.get(url)
  .then(
    function(data) {
      console.log(data);
    },
    function(error) {
      console.log(error);
    }
  )
}